#ifndef WEBPAGE_H
#define WEBPAGE_H

#include "./webviewprovider.h"

#ifdef REPOINDEX_USE_WEBENGINE
# include <QWebEnginePage>
#else
# include <QWebPage>
#endif

QT_FORWARD_DECLARE_CLASS(WEB_VIEW_PROVIDER)

namespace RepoIndex {

class WebPage : public WEB_PAGE_PROVIDER
{
    Q_OBJECT
public:
    WebPage(WEB_VIEW_PROVIDER *view = nullptr);

public slots:
    void openUrlExternal(const QUrl &url);

protected:
    WEB_PAGE_PROVIDER *createWindow(WebWindowType type);

private slots:
    void delegateToExternalBrowser(const QUrl &url);

private:
    WEB_VIEW_PROVIDER *m_view;
};

}

#endif // WEBPAGE_H
