#ifndef REPOINDEX_PACKAGEINFOLOOKUP_H
#define REPOINDEX_PACKAGEINFOLOOKUP_H

#include "./packagelookup.h"
#include "./manager.h"

namespace RepoIndex {

class PackageInfoLookup : public PackageLookup
{
    Q_OBJECT
public:
    explicit PackageInfoLookup(Manager &manager, const QJsonObject &request, QObject *parent = nullptr);

private slots:
    void performLookup();
    void addResultsDirectly(const QStringList &packageNames, const Repository *repo);
    void addResultsFromReply();

private:
    Manager &m_manager;
    const QString m_what;
    Manager::PackageInfoParts m_part;
    QJsonObject m_packageSelection;
    QList<QPair<Repository *, QStringList> > m_repos;
    QList<Package *> m_packages;

};

} // namespace RepoIndex

#endif // REPOINDEX_PACKAGEINFOLOOKUP_H
